<template>
  <article class="view view--identity-users">
    <UserListFilter :filter="filter" :sort="sort" />
    <LoadingSpinner v-if="loading" />
    <div v-else>
      <div v-if="loaded && users.length === 0">No users found.</div>
      <UserListItem v-for="user in users" :key="user.id" :user="user" />
      <PaginationNav
        v-if="showPagination"
        :total="total"
        :offset="offset"
        :limit="limit"
        singular="user"
        plural="users"
      />
    </div>
  </article>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { Constants, ValidationHelper, LoadingSpinner, PaginationNav, useApi, useNotification } from '../../../core'
import UsersApi from '../../api/users-api.js'
import UserListFilter from './user-list-filter.vue'
import UserListItem from './user-list-item.vue'

export default {
  name: 'IdentityUsersView',
  components: {
    LoadingSpinner,
    PaginationNav,
    UserListFilter,
    UserListItem,
  },
  setup() {
    const route = useRoute()
    const api = useApi()
    const notify = useNotification()
    const usersApi = new UsersApi(api)

    const loading = ref(false)
    const loaded = ref(false)
    const users = ref([])
    const total = ref(0)

    const filter = computed(() => {
      return ValidationHelper.getString(route.query.filter, '')
    })

    const sort = computed(() => {
      return ValidationHelper.getString(route.query.sort, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const showPagination = computed(() => {
      return loaded.value && total.value > limit.value
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      users.value = []

      try {
        const response = await usersApi.fetchAsync({
          q: filter.value,
          expand: 'all',
          offset: offset.value,
          limit: limit.value,
          sort: sort.value,
        })

        total.value = parseInt(response.headers['x-total-count'])
        users.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the users.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    watch(filter, async () => {
      await loadAsync()
    })

    watch(sort, async () => {
      await loadAsync()
    })

    watch(offset, async () => {
      await loadAsync()
    })

    watch(limit, async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      users,
      total,
      filter,
      sort,
      offset,
      limit,
      showPagination,
    }
  },
}
</script>
